import java.net.*;  
import java.io.*; 
import java.util.*; 
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.nio.channels.AsynchronousServerSocketChannel;
import java.nio.channels.AsynchronousSocketChannel;
import java.net.InetSocketAddress;
import java.nio.channels.CompletionHandler;
import java.nio.channels.*;

public class NetworkClient 
{        
    private ArrayList<HeroStats> list = new ArrayList<HeroStats>(); 
    private ArrayList<Shot> myShotList = new ArrayList<Shot>(); 
    private ArrayList<Shot> shotList = new ArrayList<Shot>(); 
    private HeroStats refreshStat;
    
    protected int id = -1;

    //String address = "160.217.222.200";
    //String address = "192.168.1.150";
    //String address = "127.0.0.1";
    String address = "88.100.127.215";

    private Socket s = null;
    private Socket s2 = null;

    OutputStream os = null;
    ObjectOutputStream oos = null;

    InputStream is = null;
    ObjectInputStream ois = null;
    //DataInputStream din = null;

    public NetworkClient()
    {
        establishConnection();
        Random random = new Random();
        id = random.nextInt();
    }
    
    public ArrayList<Shot> getShotList()
    {
        return shotList;
    }
    
    public ArrayList<HeroStats> getCollection()
    {
        return list;
    }
    
    public void makeShot(HeroStats stat)
    {
        if(stat.isStanding)
            myShotList.add(new Shot((int)stat.x, (int)stat.y+10, 0, 20, id));
        else
            myShotList.add(new Shot((int)stat.x, (int)stat.y+30, 0, 20, id));
    }

    public void establishConnection()
    {
        try
        {
            s = new Socket(address, 4445);
            //s2 = new Socket(address, 4446);
            s.setTcpNoDelay(true);
            //s2.setTcpNoDelay(true);

            
            os = s.getOutputStream();
            oos = new ObjectOutputStream(os);

            is = s.getInputStream(); 
            ois = new ObjectInputStream(is);
            
            receive();

        }
        catch(IOException e)
        {
            e.printStackTrace();
            System.err.print("IO Exception");
        }
        catch(Exception e)
        {
            e.printStackTrace();
            System.err.print("IO Exception");
        }

    }

    @SuppressWarnings("unchecked") //kdyz delam arraylist herostats, zeptej se Ichy, treba bude vedet
    public void send(HeroStats stats) throws IOException
    {
        //this.refreshStat = stats;
        try 
        {
            stats.id = id;
            oos.writeObject(stats);
            oos.writeObject(myShotList);
            oos.flush();
            oos.reset();
            myShotList.clear();
        }

        catch (IOException e)
        {
            e.printStackTrace();
            System.err.print("IO Exception");
        }

        if(stats.disconnect)
        {
            os.close();
            s.close();
            oos.close();
            System.out.println("Connection Closed");

        }

    }

    @SuppressWarnings("unchecked")
    public void receive()
    {
        Thread refresh = new Thread()
            {
                public void run() 
                {
                    boolean stop = false;
                    while(!stop)
                    {
                        try
                        {           
                            list = (ArrayList<HeroStats>)(ois.readObject());
                            shotList = (ArrayList<Shot>)(ois.readObject());
                            /*for (Shot tmp : shotList) 
                            {
                                System.out.println(tmp.c);
                            }*/

                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                        }

                    }
                }
            };
        refresh.start();
    }
}